<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.9) on Wed Oct 28 16:08:51 UTC 2020 -->
<title>mxGraphHierarchyModel (JGraph X 4.2.2 API Specification)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-28">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="mxGraphHierarchyModel (JGraph X 4.2.2 API Specification)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxGraphHierarchyModel.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">import hk.quantr.mxgraph.layout.hierarchical.model</a></div>
<h2 title="Class mxGraphHierarchyModel" class="title">Class mxGraphHierarchyModel</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">mxGraphHierarchyModel</span>
extends java.lang.Object</pre>
<div class="block">Internal model of a hierarchical graph. This model stores nodes and edges
 equivalent to the real graph nodes and edges, but also stores the rank of the
 cells, the order within the ranks and the new candidate locations of cells.
 The internal model also reverses edge direction were appropriate , ignores
 self-loop and groups parallels together under one edge object.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Class</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static interface&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a></span></code></th>
<td class="colLast">
<div class="block">Defines the interface that visitors use to perform operations upon the
 graph information during depth first search (dfs) or other tree-traversal
 strategies implemented by subclassers.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#dfsCount">dfsCount</a></span></code></th>
<td class="colLast">
<div class="block">Count of the number of times the ancestor dfs has been used</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#edgeMapper">edgeMapper</a></span></code></th>
<td class="colLast">
<div class="block">Map from graph edges to internal model edges</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#maxRank">maxRank</a></span></code></th>
<td class="colLast">
<div class="block">Stores the largest rank number allocated</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.lang.Object</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#parent">parent</a></span></code></th>
<td class="colLast">
<div class="block">The parent cell whose children are being laid out</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.Integer,&#8203;<a href="mxGraphHierarchyRank.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyRank</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#ranks">ranks</a></span></code></th>
<td class="colLast">
<div class="block">Mapping from rank number to actual rank</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.util.List&lt;java.lang.Object&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#roots">roots</a></span></code></th>
<td class="colLast">
<div class="block">Store of roots of this hierarchy model, these are real graph cells, not
 internal cells</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#vertexMapper">vertexMapper</a></span></code></th>
<td class="colLast">
<div class="block">Map from graph vertices to internal model nodes</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout,java.lang.Object%5B%5D,java.util.List,java.lang.Object)">mxGraphHierarchyModel</a></span>&#8203;(<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a>&nbsp;layout,
                     java.lang.Object[]&nbsp;vertices,
                     java.util.List&lt;java.lang.Object&gt;&nbsp;roots,
                     java.lang.Object&nbsp;parent)</code></th>
<td class="colLast">
<div class="block">Creates an internal ordered graph model using the vertices passed in.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createInternalCells(import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout,java.lang.Object%5B%5D,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode%5B%5D)">createInternalCells</a></span>&#8203;(<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a>&nbsp;layout,
                   java.lang.Object[]&nbsp;vertices,
                   <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>[]&nbsp;internalVertices)</code></th>
<td class="colLast">
<div class="block">Creates all edges in the internal model</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#dfs(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyEdge,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel.CellVisitor,java.util.Set,int)">dfs</a></span>&#8203;(<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;parent,
   <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;root,
   <a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&nbsp;connectingEdge,
   <a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a>&nbsp;visitor,
   java.util.Set&lt;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;seen,
   int&nbsp;layer)</code></th>
<td class="colLast">
<div class="block">Performs a depth first search on the internal hierarchy model</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#dfs(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyEdge,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel.CellVisitor,java.util.Set,int%5B%5D,int,int)">dfs</a></span>&#8203;(<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;parent,
   <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;root,
   <a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&nbsp;connectingEdge,
   <a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a>&nbsp;visitor,
   java.util.Set&lt;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;seen,
   int[]&nbsp;ancestors,
   int&nbsp;childHash,
   int&nbsp;layer)</code></th>
<td class="colLast">
<div class="block">Performs a depth first search on the internal hierarchy model.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#fixRanks()">fixRanks</a></span>()</code></th>
<td class="colLast">
<div class="block">Fixes the layer assignments to the values stored in the nodes.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getDfsCount()">getDfsCount</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getEdgeMapper()">getEdgeMapper</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getVertexMapper()">getVertexMapper</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#initialRank()">initialRank</a></span>()</code></th>
<td class="colLast">
<div class="block">Basic determination of minimum layer ranking by working from from sources
 or sinks and working through each node in the relevant edge direction.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setDfsCount(int)">setDfsCount</a></span>&#8203;(int&nbsp;dfsCount)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setEdgeMapper(java.util.Map)">setEdgeMapper</a></span>&#8203;(java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&gt;&nbsp;edgeMapper)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setVertexMapper(java.util.Map)">setVertexMapper</a></span>&#8203;(java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;vertexMapping)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#visit(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel.CellVisitor,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode%5B%5D,boolean,java.util.Set)">visit</a></span>&#8203;(<a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a>&nbsp;visitor,
     <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>[]&nbsp;dfsRoots,
     boolean&nbsp;trackAncestors,
     java.util.Set&lt;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;seenNodes)</code></th>
<td class="colLast">
<div class="block">A depth first search through the internal hierarchy model</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="maxRank">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>maxRank</h4>
<pre>public&nbsp;int maxRank</pre>
<div class="block">Stores the largest rank number allocated</div>
</li>
</ul>
<a id="vertexMapper">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>vertexMapper</h4>
<pre>protected&nbsp;java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt; vertexMapper</pre>
<div class="block">Map from graph vertices to internal model nodes</div>
</li>
</ul>
<a id="edgeMapper">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>edgeMapper</h4>
<pre>protected&nbsp;java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&gt; edgeMapper</pre>
<div class="block">Map from graph edges to internal model edges</div>
</li>
</ul>
<a id="ranks">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>ranks</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.Integer,&#8203;<a href="mxGraphHierarchyRank.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyRank</a>&gt; ranks</pre>
<div class="block">Mapping from rank number to actual rank</div>
</li>
</ul>
<a id="roots">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>roots</h4>
<pre>public&nbsp;java.util.List&lt;java.lang.Object&gt; roots</pre>
<div class="block">Store of roots of this hierarchy model, these are real graph cells, not
 internal cells</div>
</li>
</ul>
<a id="parent">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parent</h4>
<pre>public&nbsp;java.lang.Object parent</pre>
<div class="block">The parent cell whose children are being laid out</div>
</li>
</ul>
<a id="dfsCount">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>dfsCount</h4>
<pre>protected&nbsp;int dfsCount</pre>
<div class="block">Count of the number of times the ancestor dfs has been used</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;(import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout,java.lang.Object[],java.util.List,java.lang.Object)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>mxGraphHierarchyModel</h4>
<pre>public&nbsp;mxGraphHierarchyModel&#8203;(<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a>&nbsp;layout,
                             java.lang.Object[]&nbsp;vertices,
                             java.util.List&lt;java.lang.Object&gt;&nbsp;roots,
                             java.lang.Object&nbsp;parent)</pre>
<div class="block">Creates an internal ordered graph model using the vertices passed in. If
 there are any, leftward edge need to be inverted in the internal model</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>layout</code> - the enclosing layout object</dd>
<dd><code>vertices</code> - the vertices for this hierarchy</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="createInternalCells(import hk.quantr.mxgraph.layout.hierarchical.mxHierarchicalLayout,java.lang.Object[],import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createInternalCells</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;createInternalCells&#8203;(<a href="../mxHierarchicalLayout.html" title="class in import hk.quantr.mxgraph.layout.hierarchical">mxHierarchicalLayout</a>&nbsp;layout,
                                   java.lang.Object[]&nbsp;vertices,
                                   <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>[]&nbsp;internalVertices)</pre>
<div class="block">Creates all edges in the internal model</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>layout</code> - reference to the layout algorithm</dd>
<dd><code>vertices</code> - the vertices whom are to have an internal representation
            created</dd>
<dd><code>internalVertices</code> - the blank internal vertices to have their information filled
            in using the real vertices</dd>
</dl>
</li>
</ul>
<a id="initialRank()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initialRank</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;initialRank()</pre>
<div class="block">Basic determination of minimum layer ranking by working from from sources
 or sinks and working through each node in the relevant edge direction.
 Starting at the sinks is basically a longest path layering algorithm.</div>
</li>
</ul>
<a id="fixRanks()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fixRanks</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;fixRanks()</pre>
<div class="block">Fixes the layer assignments to the values stored in the nodes. Also needs
 to create dummy nodes for edges that cross layers.</div>
</li>
</ul>
<a id="visit(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel.CellVisitor,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode[],boolean,java.util.Set)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>visit</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;visit&#8203;(<a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a>&nbsp;visitor,
                  <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>[]&nbsp;dfsRoots,
                  boolean&nbsp;trackAncestors,
                  java.util.Set&lt;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;seenNodes)</pre>
<div class="block">A depth first search through the internal hierarchy model</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>visitor</code> - the visitor pattern to be called for each node</dd>
<dd><code>trackAncestors</code> - whether or not the search is to keep track all nodes directly
            above this one in the search path</dd>
</dl>
</li>
</ul>
<a id="dfs(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyEdge,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel.CellVisitor,java.util.Set,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>dfs</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;dfs&#8203;(<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;parent,
                <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;root,
                <a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&nbsp;connectingEdge,
                <a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a>&nbsp;visitor,
                java.util.Set&lt;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;seen,
                int&nbsp;layer)</pre>
<div class="block">Performs a depth first search on the internal hierarchy model</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parent</code> - the parent internal node of the current internal node</dd>
<dd><code>root</code> - the current internal node</dd>
<dd><code>connectingEdge</code> - the internal edge connecting the internal node and the parent
            internal node, if any</dd>
<dd><code>visitor</code> - the visitor pattern to be called for each node</dd>
<dd><code>seen</code> - a set of all nodes seen by this dfs a set of all of the
            ancestor node of the current node</dd>
<dd><code>layer</code> - the layer on the dfs tree ( not the same as the model ranks )</dd>
</dl>
</li>
</ul>
<a id="dfs(import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyNode,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyEdge,import hk.quantr.mxgraph.layout.hierarchical.model.mxGraphHierarchyModel.CellVisitor,java.util.Set,int[],int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>dfs</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;dfs&#8203;(<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;parent,
                <a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&nbsp;root,
                <a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&nbsp;connectingEdge,
                <a href="mxGraphHierarchyModel.CellVisitor.html" title="interface in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyModel.CellVisitor</a>&nbsp;visitor,
                java.util.Set&lt;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;seen,
                int[]&nbsp;ancestors,
                int&nbsp;childHash,
                int&nbsp;layer)</pre>
<div class="block">Performs a depth first search on the internal hierarchy model. This dfs
 extends the default version by keeping track of cells ancestors, but it
 should be only used when necessary because of it can be computationally
 intensive for deep searches.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parent</code> - the parent internal node of the current internal node</dd>
<dd><code>root</code> - the current internal node</dd>
<dd><code>connectingEdge</code> - the internal edge connecting the internal node and the parent
            internal node, if any</dd>
<dd><code>visitor</code> - the visitor pattern to be called for each node</dd>
<dd><code>seen</code> - a set of all nodes seen by this dfs</dd>
<dd><code>ancestors</code> - the parent hash code</dd>
<dd><code>childHash</code> - the new hash code for this node</dd>
<dd><code>layer</code> - the layer on the dfs tree ( not the same as the model ranks )</dd>
</dl>
</li>
</ul>
<a id="getVertexMapper()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getVertexMapper</h4>
<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;getVertexMapper()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the vertexMapping.</dd>
</dl>
</li>
</ul>
<a id="setVertexMapper(java.util.Map)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setVertexMapper</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setVertexMapper&#8203;(java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyNode.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyNode</a>&gt;&nbsp;vertexMapping)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>vertexMapping</code> - The vertexMapping to set.</dd>
</dl>
</li>
</ul>
<a id="getEdgeMapper()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEdgeMapper</h4>
<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&gt;&nbsp;getEdgeMapper()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the edgeMapper.</dd>
</dl>
</li>
</ul>
<a id="setEdgeMapper(java.util.Map)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setEdgeMapper</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setEdgeMapper&#8203;(java.util.Map&lt;java.lang.Object,&#8203;<a href="mxGraphHierarchyEdge.html" title="class in import hk.quantr.mxgraph.layout.hierarchical.model">mxGraphHierarchyEdge</a>&gt;&nbsp;edgeMapper)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>edgeMapper</code> - The edgeMapper to set.</dd>
</dl>
</li>
</ul>
<a id="getDfsCount()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDfsCount</h4>
<pre class="methodSignature">public&nbsp;int&nbsp;getDfsCount()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the dfsCount.</dd>
</dl>
</li>
</ul>
<a id="setDfsCount(int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setDfsCount</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setDfsCount&#8203;(int&nbsp;dfsCount)</pre>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>dfsCount</code> - The dfsCount to set.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxGraphHierarchyModel.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small><font size=1>Copyright (c) 2010 <a href="http://www.mxgraph.com/"
				target="_blank">Gaudenz Alder</a>. All rights reserved.</font></small></p>
</footer>
</body>
</html>
